<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'ReportCta',
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <section
    :id="data.id"
    class="report-cta"
    :class="`report-cta--${data.layout}`"
  >
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="data.statistics ? 6 : 12">
          <SlpTypography
            variant="heading2-bold"
            tag="h3"
            class="report-cta__title"
            >{{ data.title }}</SlpTypography
          >
        </SlpColumn>
        <SlpColumn v-if="data.statistics" :cols="6" class="stats-container">
          <div v-for="stat in data.statistics" :key="stat.number" class="stat">
            <SlpTypography variant="heading1-bold"
              >{{ stat.number }}
            </SlpTypography>
            <SlpTypography variant="body2-bold">{{ stat.text }} </SlpTypography>
          </div>
        </SlpColumn>
      </SlpRow>
      <SlpRow>
        <div class="reports">
          <a
            v-for="report in data.reports"
            :key="report.text"
            class="card"
            :class="data.bg_dark ? 'card--bg-purple' : ''"
            :href="report.url"
            :data-ga-name="report.data_ga_name"
            :data-ga-location="report.data_ga_location"
          >
            <nuxt-img
              v-if="report.image"
              :src="report.image"
              class="report-image"
              format="webp"
              quality="99"
            />
            <SlpIcon
              v-else
              name="news"
              variant="marketing"
              alt="Report Icon"
              size="lg"
            />
            <SlpTypography
              variant="heading4"
              tag="p"
              class="report-cta__description"
              >{{ report.description }}</SlpTypography
            >
            <div class="report-cta__link">
              <SlpButton variant="tertiary">
                <SlpTypography variant="body1-bold">
                  {{
                    `${report.link_text ? report.link_text : 'Read the report'}`
                  }}
                </SlpTypography>
                <SlpIcon
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                  class="slp-ml-8"
                />
              </SlpButton>
            </div>
          </a>
        </div>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.report-cta {
  position: relative;
  max-width: 100%;
  overflow-x: clip;
  &__link {
    display: flex;
    align-items: center;
    margin: $spacing-32 0 $spacing-8;
    color: $color-text-300;
  }

  &__title {
    margin-bottom: $spacing-24;
  }
  .reports {
    display: flex;
    flex-direction: column;
    gap: 24px;
    @media (min-width: $breakpoint-lg) {
      flex-direction: row;
    }
    .card {
      padding: 32px;
      flex: 1;
      background: white;
      color: $color-text-300;
      border-radius: 8px;
      display: flex;
      flex-direction: column;
      gap: 16px;
      max-width: 100%;
      transition: all 0.3s;
      &:hover {
        border-radius: 8px 8px 90px 8px;
      }

      @media (min-width: $breakpoint-lg) {
        max-width: 50%;
      }
      .report-cta__description {
        flex-basis: 100%;
      }

      &--bg-purple {
        background: $color-surface-800;
      }
    }

    .report-image {
      max-height: 24px;
      align-self: flex-start;
    }
  }

  .stats-container {
    display: flex;
    flex-direction: row;
    justify-content: space-around;

    .stat {
      display: flex;
      flex-direction: column;
    }
  }
  &--dark {
    // Full viewport background trick
    box-shadow: 0 0 0 100vw $color-surface-800;
    clip-path: inset(0 -100vw);
    background: $color-surface-800;
    z-index: -1;
    margin: 48px auto;
    padding: $spacing-32 0;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-96 0;
      margin: 0 auto;
    }
  }

  &--dark-shortened {
    background: $color-surface-800;
    padding: $spacing-32 0;
    margin: 48px auto 0 auto;
    @media (min-width: $breakpoint-md) {
      padding: $spacing-96 0 0 0;
      margin: 0 auto;
    }

    &:after {
      background: #f6f3fe;
      content: '';
      left: -50vw;
      height: 100%;
      position: absolute;
      top: 0;
      width: 200vw;
      z-index: -1;
    }
  }

  &--light {
    margin-top: $spacing-32;
    .reports {
      margin-top: $spacing-96;
      .card {
        background: $color-surface-800;
        .report-cta__description {
          font-size: 20px;
          font-weight: 600;
          line-height: 24px;
        }

        .report-cta__link {
          margin-top: $spacing-16;
        }
      }
    }
  }
}
</style>
